#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int compress(unsigned char* one, unsigned char* two, int size)
{
    int oneOn = 0, count, get;
    
    for (int iter = 0; iter < size; )
    {
	count = 0;
	get = two[iter];
	
	while (iter+count < size && two[iter + count] == get && count < 255) {
	    count++;
	}
	
	one[oneOn] = count;
	one[oneOn+1] = get;
	oneOn += 2;
	
	iter += count;
    }
    
    return oneOn;
}

int main()
{
    FILE *out = fopen("embed.c","wb");

    fprintf(out,"\nunsigned char *seashell_asciiData, seashell_asciiSmall[");
    
    FILE *io = fopen("ascii.bmp","rb");
    fseek(io,0,SEEK_END);
    int size = ftell(io), sizeSmall;
    fseek(io,0,SEEK_SET);

    unsigned char* bytes = malloc(size);
    fread(bytes,1,size,io);
    unsigned char* compd = malloc(size);

    sizeSmall = compress(compd,bytes,size);
    
    fprintf(out,"%i] = \"",sizeSmall);
    
    for (int iter = 0; iter < sizeSmall; iter++)
    {
	fprintf(out,"\\x%x",compd[iter]);
    }

    fclose(io);
    free(bytes);
    free(compd);
    
    //

    fprintf(out,"\";int seashell_sizeSmall = %i;\n\nunsigned char *seashell_asciiDataLarge, seashell_asciiLarge[",size);

    io = fopen("asciilarge.bmp","rb");
    fseek(io,0,SEEK_END);
    size = ftell(io);
    fseek(io,0,SEEK_SET);
    
    bytes = malloc(size);
    fread(bytes,1,size,io);
    compd = malloc(size);

    sizeSmall = compress(compd,bytes,size);
    
    fprintf(out,"%i] = \"",sizeSmall);
	
    for (int iter = 0; iter < sizeSmall; iter++)
    {
	fprintf(out,"\\x%x",compd[iter]);
    }

    fclose(io);
    free(bytes);
    free(compd);
    
    //

    fprintf(out,"\";int seashell_sizeLarge = %i;\n\nunsigned char seashell_iconData[",size);
    
    io = fopen("icon.bmp","rb");
    fseek(io,0,SEEK_END);
    size = ftell(io);
    fseek(io,0,SEEK_SET);

    fprintf(out,"%i] = \"",size);

    bytes = malloc(size);
    fread(bytes,1,size,io);

    for (int iter = 0; iter < size; iter++)
    {
	fprintf(out,"\\x%x",bytes[iter]);
    }

    fclose(io);
    free(bytes);

    fprintf(out,"\";\n");
    
    fclose(out);
    
    return 0;
}
